+++
title = "one year with Archlinux on a server"
date = "2023-09-18T19:00:00+00:00"
author = "Gibheer"
+++

It is now more than a year gone by since I left behind FreeBSD to run everything
on Archlinux.

So how is it going?

the first 6 months
-----------------

The first 6 months went rather well and I mostly set the system up in a way
how I always wanted it.
Parts of the stack got split into machined instances, network was fine and I was
finally didn't have to build new packages all the time but instead ran
the update command once every week.

ZFSonLinux gave me a bit of trouble a couple of times but that went away after
I switched to the linux-lts package for the lts Kernel.

Archlinux also wasn't the best for running Postgres. But I made do with packaging
my own version of Postgres, each major version into its own package series.
This way I can update minor versions and don't loose my database instance with
major version updates.

For certificate management I was using acme-tiny. To automate it a bit further
I wrote myself a small wrapper called [certmgmt](https://git.zero-knowledge.org/gibheer/certmgmt).

the later 6 months
------------------

The later 6 months were a bit of a sad phase. I got tired of always taking care
of 20 machined instances.
There were also some changes in a couple services I've run that required more
care than I wanted to invest.

One of these things was taking care of certificates. Sometimes the certificate
management broke out of the blue and caused some unnecessary downtime.

So I moved some websites that were php based before into static websites and
replaced nginx with caddy to take care of certificate management.
Not all went well, but at the moment, everything works better than before.

So now I am down to only 5 machined instances. It is by far much less work
overall and much less breakage.
It could probably work better if I automated the update and installation
process a bit. I have some ideas on how to do that, but I am missing the time.

Is it better?
-------------

But is it better overall? In comparison to the FreeBSD setup I had before, it
feels better and more stable.
Until now I only had one kernel issue with ZFS, which was resolved by switching
to the LTS kernel.
But being able to utilize systemd with all its features definitely helped a lot.

Would I ever go back to FreeBSD?

If I would be able to run systemd (or a similar tool with very good tooling)
on FreeBSD, I think I would switch back instantly.
I miss pf and some of the really good tools of FreeBSD, but the quality of
Archlinux and systemd is definitely there.

And who knows, maybe the next cow Filesystem [bcachefs](https://git.kernel.org/pub/scm/linux/kernel/git/next/linux-next.git/commit/?id=94dd1c72d0e882ffd01f929daf06c38924d8447b) makes ZFS obsolete on
Linux.
It would be sad, because running [multiple OS' from one zpool](129.md) is working great,
but sadly that isn't needed as often.

But it would be nice if FreeBSD could make some kind of come back, just to keep
the competition alive.
